/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Julien Kindle
 *   Co-authors:
 *      
 *
 */

/**
    @file SOBCoin.h
    @brief Declaration of the SOBCoin class.
    @ingroup SOB
*/

#ifndef _SOBCoin_H__
#define _SOBCoin_H__

#include "superorxobros/SOBPrereqs.h"
#include "worldentities/MovableEntity.h"


namespace orxonox
{
    class _SOBExport SOBCoin : public MovableEntity
    {
    public:
        SOBCoin(Context* context);
        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
        virtual void tick(float dt) override;


        bool attachedToFigure_;

        void setLifetime(const float lt)
        { this->lifetime_ = lt; }
        float getLifetime() const
        { return lifetime_; }
        void setSpeed(const float lt)
        { this->speed_ = lt; }
        float getSpeed() const
        { return speed_; }


    protected:

        float lifetime_;
        float speed_;

    };
}

#endif /* _SOBCoin_H__ */
